//
//  BFKit.h
//  BFKit
//
//  The MIT License (MIT)
//
//  Copyright (c) 2014 - 2017 Fabrizio Brancati. All rights reserved.
//
//  Permission is hereby granted, free of charge, to any person obtaining a copy
//  of this software and associated documentation files (the "Software"), to deal
//  in the Software without restriction, including without limitation the rights
//  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//  copies of the Software, and to permit persons to whom the Software is
//  furnished to do so, subject to the following conditions:
//
//  The above copyright notice and this permission notice shall be included in all
//  copies or substantial portions of the Software.
//
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
//  SOFTWARE.

/**
 *  BFKit version string
 */
#define BFKIT_VERSION @"1.9.1"
/**
 *  BFKit author string
 */
#define BFKIT_AUTHOR @"Fabrizio Brancati"

/**
 *  BFKit Classes
 */
#import "BFApp.h"
#import "BFButton.h"
#import "BFCryptor.h"
#import "BFDataStructures.h"
#import "BFLog.h"
#import "BFPassword.h"
#import "BFSystemSound.h"
#import "BFTextField.h"
#import "BFTouchID.h"

/**
 *  Foundation Categories
 */
#import "NSArray+BFKit.h"
#import "NSData+BFKit.h"
#import "NSDate+BFKit.h"
#import "NSDictionary+BFKit.h"
#import "NSFileManager+BFKit.h"
#import "NSMutableArray+BFKit.h"
#import "NSMutableDictionary+BFKit.h"
#import "NSNumber+BFKit.h"
#import "NSObject+BFKit.h"
#import "NSProcessInfo+BFKit.h"
#import "NSString+BFKit.h"
#import "NSThread+BFKit.h"

/**
 *  UIKit Categories
 */
#import "UIBarButtonItem+BFKit.h"
#import "UIButton+BFKit.h"
#import "UIColor+BFKit.h"
#import "UIDevice+BFKit.h"
#import "UIFont+BFKit.h"
#import "UIImage+BFKit.h"
#import "UIImageView+BFKit.h"
#import "UILabel+BFKit.h"
#import "UINavigationBar+BFKit.h"
#import "UIScreen+BFKit.h"
#import "UIScrollView+BFKit.h"
#import "UITableView+BFKit.h"
#import "UITextField+BFKit.h"
#import "UITextView+BFKit.h"
#import "UIToolbar+BFKit.h"
#import "UIView+BFKit.h"
#import "UIWebView+BFKit.h"
#import "UIWindow+BFKit.h"
